import obs
from read_line import Read_line
from nmea import parser
from nmea_decoder import NmeaDecode, VALUE, PARAM
from sensor_drv import SensorDrv

class NmeaPtid(SensorDrv):
  def __init__(self, serial, conf):
    self.__nmea_decoder = NmeaDecode()
    SensorDrv.__init__(self)
    self.__serial_data = Read_line(serial)
    self.__data = []
 
  async def read_values(self):
    result = await self.__serial_data.update()
    if result: 
      for line in result:
        self.__data = self.__nmea_decoder.decode(line)
        if self.__data:
          self.data = [self.__data[1][VALUE],self.__data[2][VALUE],self.__data[3][VALUE],self.__data[4][VALUE]]
          return True
    return False

  async def detect_parameters(self, tag_number = ''):
    if await self.read_values():
      params = [self.__data[1][PARAM],self.__data[2][PARAM],self.__data[3][PARAM],self.__data[4][PARAM]]
      for param in params:
        self.parameters.append((param[0], param[1], param[2] + tag_number))
      return True

  async def flush(self):
    await self.__serial_data.flush()


